# Contribution Guideline

## Contribution Welcome!

OpenMLDB is a community-driven opensource project. We welcome all kinds of contributions, such as bugfix, new feature development, test cases, documentations and so on. 

## OpenMLDB Contribution Workflow

### Before Opening Your PR

We encourage you to discuss with us first before coding. Your discussion channel may depend on what you want to contribute:

- If it is a simple bugfix, or an independent function/module that will not affect other modules: You may just raise an issue on our [GitHub Issues](https://github.com/4paradigm/OpenMLDB/issues) and describe your solutions. We will provide necessary feedback to you as soon as possible.
- If the change may affect a few modules, or an architectural change/improvement: Please contact us in the community and let us have more understanding about your ideas. Meanwhile, we also encourage you to write a formal RFC and post it to the [GitHub Discussions](https://github.com/4paradigm/OpenMLDB/discussions/categories/rfcs).

### Code Contribution Workflow

Here is the general contribution workflow:

- Fork the OpenMLDB repository into your personal space
- Create a branch from where you want to base your code (usually it is the main branch)
- Make commits of your code and test cases, make sure:
  - your coding style follows our [code convention](https://github.com/4paradigm/rfcs/blob/main/style-guide/code-convention.md) 
  - the commit messages follow our [commit convention](https://github.com/4paradigm/rfcs/blob/main/style-guide/commit-convention.md)

- Push your commits to your forked repository
- Submit a pull request to merge from your branch to the OpenMLDB's base branch
- Address any comments from our community about your PR
- The PR will be merged by our maintainers after all comments are addressed.

## Contribution Help

You may find us from the following channels for any help about contribution

- [GitHub Issues](https://github.com/4paradigm/OpenMLDB/issues) and [GitHub Discussions](https://github.com/4paradigm/OpenMLDB/discussions)
- [Slack](https://join.slack.com/t/openmldb/shared_invite/zt-ozu3llie-K~hn9Ss1GZcFW2~K_L5sMg)
- WeChat Group (Chinese)
  <img src="images/wechat.png" alt="img" width=100 />  

## Contribution Opportunities

If you just would like to begin your journey to contribute to OpenMLDB community, the issues with the label of `good first issue` is certainly a good start for you. [Please visit here for this issue list](https://github.com/4paradigm/OpenMLDB/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22).

Please also stay tuned to our **Contributor Challenges** (with prize :gift: ) : 

- [Collection 1, Dec 2021](https://github.com/4paradigm/OpenMLDB/issues/825)

## Contributors

We appreciate the effort from all of our contributors. You can find the [full list here](https://github.com/4paradigm/OpenMLDB/graphs/contributors).